- #
- # sshnfs - remote login client with NFSv4 forwarding
- #
- #
- # parse url
- #
- # returns:
- # data.protocol
- # data.host
- # data.port (optional)
- # data.path
- #
- function parse_url
- {
- typeset url="$2"
- typeset leftover
- nameref data="$1"
- leftover="${url//~(Elr)(.+?):\/\/(.+?)(?:|:([[:digit:]]+))(?:\/(.*?))?/x}"
- [[ "$leftover" == 'x' ]] || { print -u2 -f $"%s: Parser error\n" "$0" ; return 1 ; }
- #print -v .sh.match
- data.protocol="${.sh.match[1]}"
- data.host="${.sh.match[2]}"
- # bug: should be [[ -v .sh.match[3] }}, but ksh93u has bugs
- [[ "${.sh.match[3]}" != '' ]] && integer data.port="${.sh.match[3]}"
- data.path="${.sh.match[4]}"
- return 0
- }
- function parse_nfs_url
- {
- typeset url="$2"
- nameref data="$1"
- parse_url data "$url" || return 1
- [[ "${data.protocol}" == 'nfs' ]] || { print -u2 -f $"%s: Not a NFS url\n" "$0" ; return 1 ; }
- if [[ ! -v data.port ]] ; then
- integer data.port=2049
- fi
- return 0
- }
- function main
- {
- compound c
- compound c.nfs_data
- integer c.forward_port=4049
- set -x
- url="$1"
- shift
- parse_nfs_url c.nfs_data "$url" || return 1
- # $ ssh -f ... # puts the ssh process into the bachground, but
- # we have no way to determinate the process id. The "fix" is
- # to start a new process, and then use exec(1) to re-use the
- # process id of the shell for that ssh process
- print -v c >"mydata"
- ksh -c 'set -o errexit -o xtrace ; read -C c <"mydata" ; printf "%d\n" $$ >"mypid" ; exec ssh -L "${c.forward_port}:localhost:${c.nfs_data.port}" -N -f -o ExitOnForwardFailure=yes "root@${c.nfs_data.host}"'
- (( $? == 0 )) || { printf $"%s: NFS forwarding ssh failed with error code %d\n" "$0" $? ; return 1 ; }
- (( c.forward_pid=$( <'mypid') ))
- #rm 'mypid'
- ssh -Y -R "3049:localhost:${c.forward_port}" root@10.49.20.207
- kill -s TERM "${c.forward_pid}"
- wait
- return 0
- }
- main "$@"
- # EOF.
sshnfs - ssh with nfs forwarding
Posted by Anonymous on Wed 8th Feb 2023 13:33
raw | new post
view followups (newest first): sshnfs - ssh with nfs forwarding by Anonymous
Submit a correction or amendment below (click here to make a fresh posting)
After submitting an amendment, you'll be able to view the differences between the old and new posts easily.